<script lang="ts">
  import { userStore, langStore } from "$lib/stores";
  import type { Event } from "$lib/types";
  import LoginModal from "./LoginModal.svelte";
  import RegisterModal from "./RegisterModal.svelte";
  import CreateEventModal from "./CreateEventModal.svelte";
  import { onMount } from "svelte";
  import { del, get } from "$lib/httpService";
  import LanguageChanger from './LanguageChanger.svelte';



  let events: Event[] | null = null;
  let showLoginModal = false;
  let showRegisterModal = false;
  let showCreateEventModal = false;

  async function loadAllEvents() {
    try {
      const data = await get<Event[]>("api/Event");
      if (data && data.length) events = data;
      else events = [];
    } catch (e) {
      console.error(e);
      alert(e);
    }
  }

  langStore.subscribe(lang => {
    loadAllEvents();
  });

  async function deleteEvent(eventId: number) {
    try {
      await del(`api/Event/${eventId}`);
      await loadAllEvents();
    } catch (e) {
      console.error(e);
      alert(e);
    }
  }

  async function logout() {
    userStore.set(null);
    await del("api/User/logout");
  }

  onMount(() => {
    loadAllEvents();
  });

  function closeModal() {
    showLoginModal = false;
    showRegisterModal = false;
    showCreateEventModal = false;
  }

  function activateModal(modal: "login" | "register" | "createEvent") {
    closeModal();
    switch (modal) {
      case "login":
        showLoginModal = true;
        break;
      case "register":
        showRegisterModal = true;
        break;
      case "createEvent":
        showCreateEventModal = true;
        break;
    }
  }
</script>

<!-- Top Bar -->
<div class="top-bar">
  <LanguageChanger /> 
  {#if $userStore}
    <span>Welcome, {$userStore?.displayName}</span>
    <button on:click={() => logout()}>Logout</button>
    {#if $userStore?.organizer}
      <button on:click={() => activateModal("createEvent")}
        >Create New Event</button
      >
    {/if}
  {:else}
    <div class="top-bar-right">
      <button on:click={() => activateModal("login")}>Login</button>
      <button on:click={() => activateModal("register")}>Register</button>
    </div>
  {/if}
</div>

<!-- Main Content -->
<div class="main-content">
  <h1>Welcome to Eventom</h1>
  <p>You can totally book all the events here!</p>
  <button on:click={() => loadAllEvents()}>Get all events</button>

  {#if events == null}
    <p>No events loaded yet, press the button to load events.</p>
  {:else if events.length === 0}
    <p>No events found</p>
  {:else}
    <div class="event-grid">
      {#each events as event}
        <div class="event-item">
          <h2>{event.name}</h2>
          <p>{event.description}</p>
          <p>{event.start}</p>
          <p>{event.end}</p>
          {#if $userStore?.organizer && event.ownerEmail === $userStore?.email}
            <button on:click={() => deleteEvent(event.id)}>Delete</button>
          {/if}
        </div>
      {/each}
    </div>
  {/if}
</div>

<!-- Modals -->
{#if showLoginModal}
  <LoginModal on:close={() => (showLoginModal = false)} />
{/if}

{#if showRegisterModal}
  <RegisterModal on:close={() => (showRegisterModal = false)} />
{/if}

{#if showCreateEventModal}
  <CreateEventModal
    on:close={() => (showCreateEventModal = false)}
    on:success={() => {
      showCreateEventModal = false;
      loadAllEvents();
    }}
  />
{/if}

<style>
  /* Base styles */
  body,
  html {
    margin: 0;
    padding: 0;
    font-family: "Arial", sans-serif;
    background-color: #f4f4f4;
  }

  /* Top Bar */
  .top-bar {
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding: 10px 20px;
    background-color: #333;
    color: #fff;
  }

  .top-bar-right {
    margin-left: auto;
  }

  /* Main Content */
  .main-content {
    padding: 20px;
    max-width: 1200px; /* Maximum width */
    margin: 0 auto; /* Centering */
  }

  /* Responsive grid for events */
  .event-grid {
    display: grid;
    grid-template-columns: repeat(auto-fill, minmax(300px, 1fr));
    gap: 20px;
    padding: 20px;
  }

  .event-item {
    background-color: white;
    border: 1px solid #ddd;
    padding: 15px;
    border-radius: 8px;
    box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
  }

  /* Buttons and Inputs */
  button,
  input,
  textarea {
    padding: 10px;
    margin: 5px 0;
    border-radius: 5px;
    border: 1px solid #ddd;
  }

  button {
    background-color: #5c6bc0;
    color: white;
    border: none;
    cursor: pointer;
  }

  button:hover {
    background-color: #3f51b5;
  }

  input,
  textarea {
    width: 100%; /* Full width */
  }

  /* Media Queries for Responsive Design */
  @media (max-width: 768px) {
    .top-bar {
      flex-direction: column;
      align-items: flex-start;
    }

    .event-grid {
      grid-template-columns: 1fr; /* Single column on small screens */
    }
  }
</style>
